#!/usr/bin/perl -w
# -T can only be given on the command line (taint checking)
use strict; # homework by Eric Auer...
use English; # to have $MATCH $PREMATCH $POSTMATCH

my $WHAT = "test.html";
my $newcr = "\n";              # set this to " " to remove "\n",
                               # set to "\n" to keep "\n" !

sub onthtml { # arg is a filename, returns content w/o HTML tags
  my $a =  $_[0]; # copy arg
  unless (open(FIL,"<$a")) {
    print STDERR "Cannot read file <$a>\n";
    return "";
  }
  my @binnen = <FIL>;
  close(FIL);
  my $out = "";
  my $text = join($newcr,@binnen);
                                # kill line breaks as tags
                                # may be multiline anyway
                                # (use s option otherwise to
                                # treat \n as simple . (any))

  $text =~ s/^.*[\/]head>//gsi; # remove head part + style

  $text =~ s/<!--.*?-->//gs;    # ungreedily remove remarks
                                # (which may contain tags!)
  $text =~ s/<[^>]*>//gs;       # ungreedily remove all tags

  # for testing:
  $text =~ s/[&]nbsp;/ /gsi;    # un-nonbreak spaces
  $text =~ s/[&][a-zA-Z#][^;]*;/_/gs; # replace special chars
  # see perlre... we could tr away all char not in some set...

  if ($newcr eq "\n") {
    $text =~ s/[^\S\n][^\S\n]+/ /gs; # compress spaces
                                # (non-non-(whitespace or \n))
    $text =~ s/\n+/\n/gs;       # make multi-cr to single-crs
  } else {
    $text =~ s/[\s\n][\s\n]+/ /gs;   # compress spaces and \n
  }
  return $text;
}

print "$WHAT has the text:\n\n";
print "(START)\n" . &onthtml($WHAT) . "\n(END)\n";

