#!/usr/bin/perl -w
# -T can only be given on the command line (taint checking)
use strict; # homework by Eric Auer...

sub evenlang { # check for equal length of two arrays ref'd by args
  my ($ref_a,$ref_b) = @_;	# copy args
  return ( @$ref_a == @$ref_b ); # scalar context of == leads to
                                 # comparing the numbers of elements
}

my @a = qw/foo bar baz/;
my @b = qw/aap noot mies/;
my @c = qw/n w s e/;

print "Is <@a> as long as <@b> ? "
  . ((&evenlang(\@a,\@b)) ? "yes" : "no") . "!\n";

print "Is <@a> as long as <@c> ? "
  . ((&evenlang(\@a,\@c)) ? "yes" : "no") . "!\n";

