#!/usr/bin/perl -w
# -T can only be given on the command line (taint checking)
use strict; # homework by Eric Auer...

sub prefix { # check if string arg1 is prefix of string arg2
  my ($a,$b) =  @_; # copy args
  if (length($a) > length($b)) { return 0; }; # false: cannot be prefix
  my @aa = split("",$a); # string to array, arg1
  my @bb = split("",$b); # string to array, arg2
  my $i;
  for ($i = 0; $i < $#aa ; $i++) {
    if ( $aa[$i] ne $bb[$i] ) { 
      return 0;
    }; # false: differs, no prefix
  };
  return 1; # true
}

print "Is bar a prefix of barefooted ? "
  . ((&prefix("bar","barefooted")) ? "yes" : "no") . "!\n";

print "Is foo a prefix of barefooted ? "
  . ((&prefix("foo","barefooted")) ? "yes" : "no") . "!\n";

